#include <stdio.h>
#include <stdlib.h>

//-------------------------------------------------------
typedef char DType;
int cmp(DType d1, DType d2);
char *toString(char *buf, DType d);
int cmp(DType d1, DType d2) {
    return d1 - d2;
}
char *toString(char *buf, DType d) {
    sprintf(buf, "%c", d);
    return buf;
}
//-------------------------------------------------------
struct SStack {
    DType *data;
    int length;
    int size;
};
typedef struct SStack *Stack;
//-------------------------------------------------------
Stack newStack(int length) {
    Stack s = malloc(sizeof(Stack));
    s->data = (DType *) malloc(length * sizeof(DType));
    s->length = length;
    s->size = 0;
    return s;
}
void freeStack(Stack s) {
    free(s->data);
    free(s);
}
//-------------------------------------------------------
int sizeOfStack(Stack s) {
    return s->size;
}
int isEmptyStack(Stack s) {
    return s->size == 0;
}
//-------------------------------------------------------
void printStack(Stack s) {
    int i;
    printf("stack:[ ");
    char buf[100];
    for (i=0; i<s->size; i++) {
        printf("%s ", toString(buf, s->data[i]));
    }
    printf("]\n");
}
//-------------------------------------------------------
void push(Stack s, DType x) {
    if (s->size >= s->length) {
        int newlength = 2*s->length;
        DType *arr = (DType *) malloc(newlength * sizeof(DType));
        int i;
        for (i=0; i<s->size; i++) {
            arr[i] = s->data[i];
        }
        free(s->data);
        s->data = arr;
        s->length = newlength;
    }
    s->data[(s->size)++] = x;
}
DType top(Stack s) {
    if (s->size == 0) {
        printf("Stack is empty !");
        exit(1);
    } else {
        return s->data[s->size - 1];
    }
}
DType pop(Stack s) {
    DType x = top(s);
    --(s->size);
    return x;
}
//-------------------------------------------------------



