#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//---------------------------------------------
typedef char DType;
//---------------------------------------------
struct SStack;
typedef struct SStack *Stack;
Stack newStack(int length);
void freeStack(Stack s);
int sizeOfStack(Stack s);
int isEmptyStack(Stack s);
void printStack(Stack s);
void push(Stack s, DType x);
DType top(Stack s);
DType pop(Stack s);
//---------------------------------------------
char *operators = "+-*/^()";
int outP[] = { 3, 3, 5, 5, 7, 9, 1 };
int inP[] = { 3, 3, 5, 5, 7, 0 };
//---------------------------------------------
int operatorIndex(char op) {
    int i;
    for (i=0; operators[i]!='\0'; i++) {
        if (operators[i] == op) return i;
    }
    return -1;
}
int outPriority(char op) {
    return outP[operatorIndex(op)];
}
int inPriority(char op) {
    return inP[operatorIndex(op)];
}
int isOperator(char op) {
    return operatorIndex(op) >= 0;
}
void infix2postfix(char *infix, char *postfix) {
    int n = strlen(infix);
    Stack s = newStack(n);
    int i, j = 0;
    for (i = 0; i < n; i++) {
        char token = infix[i];
        if (!isOperator(token)) {
            postfix[j++] = token;
        } else {
            int p = outPriority(token);
            while (!isEmptyStack(s) &&
                   inPriority(top(s)) >= p) {
                postfix[j++] = pop(s);
            }
            if (token == ')') pop(s); else push(s, token);
        }
    }
    while (!isEmptyStack(s)) {
        postfix[j++] = pop(s);
    }
    postfix[j] = '\0';
    freeStack(s);
}
//---------------------------------------------
int main() {
    char infix[100];
    char postfix[100];
    while (1) {
        printf("infix = ");
        scanf("%s", infix);
        if (strcmp(infix, ".") == 0) break;
        infix2postfix(infix, postfix);
        printf("%s\n", postfix);
    }
    return 0;
}
